#include <algorithm>
#include <vector>
#include <cstdio>
#include <set>

struct t_edge {
	inline t_edge(long _a, long _b , long _w): a(_a), b(_b), w(_w) {}
	inline t_edge() {}
	long a, b, w;
};

int main(int argc, char *argv[]) {
	//...
	long num_edge, num_vert = atol(argv[1]), max = atol(argv[2]); srand(atoi(argv[3]));
	long len_edge = rand() % max;
	//...
	long id0 = rand() % num_vert;
	long id1 = (id0 + 1 + rand() % (num_vert - 1)) % num_vert;
	long id2 = (id0 + 1 + rand() % (num_vert - 1)) % num_vert;
	//...
	std::vector<t_edge> EDGE;
	for (long i = 0; i < num_vert; ++ i) for (long j = 0; j < i; ++ j) {
		EDGE.push_back(t_edge(i, j, len_edge));
	}
	//...
	std::random_shuffle(EDGE.begin(), EDGE.end());
	num_edge = EDGE.size();
	//...
	FILE *fid = fopen("input.txt", "wt");
	fprintf(fid, "%li %li\n\n", num_vert, num_edge);
	for (long i = 0; i < num_edge; ++ i) {
		t_edge ed = EDGE[i];
		fprintf(fid, "%li %li ", ed.a, ed.b);
		fprintf(fid, "%li\n", ed.w);
	}
	fprintf(fid, "\n");
	fprintf(fid, "%li\n", id0);
	fprintf(fid, "%li\n", id1);
	fprintf(fid, "%li", id2);
	fclose(fid);
	//...
	return 0;
}
